vector posP = position_;
label cellP = 1; 
label tetFaceP = 1; 
label tetPtP = 1; 
mesh_.findCellFacePt(posP, cellP, tetFaceP, tetPtP); // Revise the command myself (mesh_ & posP). CHECK IT
// label cellP=mesh.findCell(posP); 
scalar alphaWP = td.alphaWInterp().interpolate(posP, cellP); //
scalar distanceP = d_/2.0+(pow(mesh_.cellVolumes()[cellP],1.0/3.0))/2.0; // works exactly just for cubic cells!!!
bool closeVOF= false;
for (int j=0; j<6;j++)
 {
  int sign = pow(-1.0,j);
  int coord = j/2;
  vector possurfP = posP;
  possurfP.component(coord) += sign * distanceP ;
  label cellsurfP = 1; 
  label tetFacesurfP = 1; 
  label tetPtsurfP = 1; 
  mesh_.findCellFacePt(posP, cellsurfP, tetFacesurfP, tetPtsurfP); // Revise the command myself (mesh_ & posP). CHECK IT
//  label cellsurfP=mesh.findCell(possurfP); 
  if (cellsurfP != (-1))
   {
    scalar alphaWsurfP = td.alphaWInterp().interpolate(possurfP, cellsurfP); //
    if (alphaWsurfP > 0.5)
     {
      closeVOF=true;
     }
   }
 }
Info<< "Close VOF "<< closeVOF<<endl;
scalar VPleft;
scalar VdispoCellP;
if (closeVOF)
 {
  VPleft=pow(d_,3)*constant::mathematical::pi/6.0;
 VdispoCellP=(1-alphaWP)*mesh_.cellVolumes()[cellP]; //
  Info<< "We remove the particle at position "<< posP << "  with volume "<< VPleft<<endl;
  td.keepParticle = false;

 if (VPleft <= VdispoCellP)
  // fill only the eulerian cell at the particle position
   {
    td.cloud().correctalphaW()[cellP] +=  VPleft/mesh_.cellVolumes()[cellP] ; //
    td.cloud().correctU()[cellP] += U_  ;  // 1. the formulation may not be well developed. 2. command not compatible with OF 3.
    Info<< "CellP has alpha= " <<alphaWP << " Add liquid to cellP: "<< cellP << "  "<< td.cloud().correctalphaW()[cellP] << "  "<< td.cloud().correctU()[cellP] <<endl;
  }
 else
  // start to fill the neighbour cells
   {
    //we don't need it for this simple tutorial
   }
  }
