
//evaluate thetac
vector p = p2().position() - p1().position();
scalar dist = mag(p);
scalar sumR = (p1().d() + p2().d())/2.0;
scalar thetac = atan(sumR/ sqrt(sqr(dist)-sqr(sumR)));  // Ebrahim: I revised the denominator!
// evaluate theta
vector v1 = p1().U();
vector v2 = p2().U();
vector vRel = v1 - v2;
scalar magVRel = mag(vRel);
scalar theta = acos( (vRel/(magVRel+SMALL)) & (p/(dist+SMALL)) );
if ( theta <thetac)
{
Info<< "theta smaller than thetac"<<endl;
// evaluate dcoll
scalar dt = mesh_.time().deltaT().value();
scalar vcoll = vRel & (p/(dist+SMALL));
scalar dcoll = vcoll * dt;
// evaluate dcollc
scalar denom=1.0+sqr(tan(theta));
scalar dcollc = 2* dist -2* sqrt(sqr(dist) - denom*(sqr(dist)-sqr(sumR)));
dcollc /= (2*denom);
if (dcoll > dcollc)
{
collision=true;
Info<<"collision occurs"<<endl;
} // if - collision distance
} // if - collision angle
